package {

	import com.citrusengine.objects.PhysicsObject;
	import com.citrusengine.objects.platformer.Sensor;

	import flash.utils.clearTimeout;
	import flash.utils.setTimeout;

	/**
	 * @author Aymeric
	 */
	public class Teleporter extends Sensor {
		
		public var endX:Number;
		public var endY:Number;
		public var object:PhysicsObject;
		
		public var time:Number = 0;
		public var needToTeleport:Boolean = false;
		
		protected var _teleporting:Boolean = false;
		
		private var _teleportTimeoutID:uint;

		public function Teleporter(name:String, params:Object = null) {
			super(name, params);
		}
		
		override public function destroy():void {
			
			clearTimeout(_teleportTimeoutID);

			super.destroy();
		}
		
		override public function update(timeDelta:Number):void {

			super.update(timeDelta);
			
			if (needToTeleport) {
				
				_teleporting = true;
				
				_teleportTimeoutID = setTimeout(_teleport, time);
				
				needToTeleport = false;
			}
			
			_updateAnimation();
		}

		protected function _teleport():void {
			
			_teleporting = false;
			
			object.x = endX;
			object.y = endY;
			
			clearTimeout(_teleportTimeoutID);
		}
		
		protected function _updateAnimation():void {
			
			if (_teleporting) {
				_animation = "teleport";
			} else {
				_animation = "normal";
			}			
		}		
	}
}